
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>3D UNET+ Seeded watershed &#8212; seg_compare 0.0.1 documentation</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">3D UNET+ Seeded watershed</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="d-unet-seeded-watershed">
<h1>3D UNET+ Seeded watershed<a class="headerlink" href="#d-unet-seeded-watershed" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><b>Original repository</b>:  <a href="https://bitbucket.org/jstegmaier/cellsegmentation/src/ISBI2019/"> https://bitbucket.org/jstegmaier/cellsegmentation/src/ISBI2019 </a></p></li>
<li><p><b>Paper citation </b> : <i>Eschweiler D, Spina TV, Choudhury RC, Meyerowitz E, Cunha A, Stegmaier J. CNN-Based Preprocessing to Optimize Watershed-Based Cell Segmentation in 3D Confocal Microscopy Images. 2019 IEEE 16th International Symposium on Biomedical Imaging (ISBI 2019). IEEE; 2019. pp. 223–227. doi:10.1109/ISBI.2019.8759242 </i></p></li>
<li><p><b>Concept</b>: Use a 3D U-Net to predict cell boundary, cell interior and image background regions, use outputs of the 3D U-Net to generate a seed map for final seeded watershed based 3D segmentation.</p></li>
</ul>
<div align="center">
<img src="../_static/unet_ws_pipeline.png" alt="Unet_ws pipeline" width="1000" height="250"/>
<figcaption>Schematic diagram of the 3D UNet+Watershed pipeline</figcaption>
</div>
<div class="section" id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">¶</a></h2>
<ol>
<li><p>Create and activate a new environment as follows:</p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">create</span> <span class="pre">-n</span> <span class="pre">unet_ws</span> <span class="pre">python=3.6</span> <span class="pre">anaconda</span></code></p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">activate</span> <span class="pre">unet_ws</span></code></p>
</li>
<li><p>Install pip:</p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">install</span> <span class="pre">-c</span> <span class="pre">anaconda</span> <span class="pre">pip</span></code></p>
</li>
<li><p>Clone the ISBI2019 branch at <a href="https://bitbucket.org/jstegmaier/cellsegmentation/src/ISBI2019/ ">  https://bitbucket.org/jstegmaier/cellsegmentation/src/ISBI2019/  </a> using:</p>
<p><code class="docutils literal notranslate"><span class="pre">git</span> <span class="pre">clone</span> <span class="pre">-b</span> <span class="pre">ISBI2019</span> <span class="pre">https://bitbucket.org/jstegmaier/cellsegmentation.git</span></code></p>
</li>
<li><p>Navigate inside the folder <code class="docutils literal notranslate"><span class="pre">cellsegmentation</span></code> and install the dependencies using:</p>
<p><code class="docutils literal notranslate"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">-r</span> <span class="pre">requirements.txt</span></code></p>
<p>The current (2020) versions of the libraries are the following:</p>
<p>absl-py==0.9.0
astor==0.7.1
certifi==2018.10.15
cloudpickle==0.6.1
cycler==0.10.0
dask==0.19.4
decorator==4.3.0
emoji==0.5.1
gast==0.2.2
grpcio==1.15.0
h5py==2.8.0
Keras==2.2.4
Keras-Applications==1.0.8
Keras-Preprocessing==1.0.5
kiwisolver==1.0.1
Markdown==3.0.1
matplotlib==3.0.0
networkx==2.2
numpy==1.16.0
pandas==0.23.4
Pillow==5.3.0
protobuf==3.6.1
pyparsing==2.2.2
python-dateutil==2.7.3
pytz==2018.5
PyWavelets==1.0.1
PyYAML==3.13
scikit-image==0.15
scikit-learn==0.20.0
scipy==1.1.0
setuptools==41.0.0
six==1.11.0
tensorboard==1.15.0
tensorflow-gpu==1.15
termcolor==1.1.0
toolz==0.9.0
Werkzeug==0.15</p>
</li>
<li><p>Deactivate the conda environment:</p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">deactivate</span></code></p>
</li>
<li><p>Install the <code class="docutils literal notranslate"><span class="pre">mars</span></code> environment following the installation steps described in the <a class="reference internal" href="mars_pipeline.html"><span class="doc std std-doc">MARS</span></a> pipeline.</p></li>
</ol>
</div>
<div class="section" id="uses">
<h2>Uses<a class="headerlink" href="#uses" title="Permalink to this headline">¶</a></h2>
<p>The segmentation of an image using <code class="docutils literal notranslate"><span class="pre">unet_ws</span></code> method requires a trained model. This model can be obtained in two different ways:</p>
<ul class="simple">
<li><p>Download one of the proposed <a href="https://doi.org/10.6084/m9.figshare.14433590.v1">  trained models </a></p></li>
<li><p>Train your own model using either your data or the proposed <a href="https://www.repository.cam.ac.uk/handle/1810/262530 "> training data  </a> (see <a class="reference internal" href="dataset.html"><span class="doc std std-doc">Datasets</span></a>).</p></li>
</ul>
<p><b>Train your own model</b></p>
<ul>
<li><p><b>Dataset preparation</b>: For training, save the pathnames of images (membraneX_image) and corresponding ground truth segmentations (masks) in the following format in a text file (filelist.txt):</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>                    `path/to/membrane01_image.tif    path/to/membrane01_mask.tif`

                    `path/to/membrane02_image.tif    path/to/membrane02_mask.tif`
</pre></div>
</div>
</li>
<li><p><b>Training environment</b>: Invoke the training environment using :</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>`conda activate unet_ws`. 
</pre></div>
</div>
</li>
<li><p><b>Model training</b>: The training can be invoked using the following command:</p>
<p><code class="docutils literal notranslate"><span class="pre">python</span> <span class="pre">pipeline.py</span> <span class="pre">--list_path</span> <span class="pre">path_to_filelist.txt</span> <span class="pre">--data_path</span> <span class="pre">path/to/data</span> <span class="pre">--eval_path</span> <span class="pre">path/to/save/results/to</span>&#160; <span class="pre">--comment</span> <span class="pre">experiment_name</span></code></p>
<p>After training the prediction on test images can be invoked by :</p>
<p><code class="docutils literal notranslate"><span class="pre">python</span> <span class="pre">pipeline.py</span> <span class="pre">--no_train</span> <span class="pre">--list_path</span> <span class="pre">path_to_filelist</span> <span class="pre">--data_path</span> <span class="pre">path/to/data</span> <span class="pre">--comment</span> <span class="pre">test_folder</span></code></p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>Where test_folder is a folder containing the trained model.hdf5 . The names of the files to test should be mentioned in the filelist in the format shown above. 
</pre></div>
</div>
</li>
</ul>
<p><b>Use a model</b></p>
<ul class="simple">
<li><p><b>Post-processing</b>: Use predictions from the 3D Unet with the <b>”Unet_WS_postproc.ipynb”</b> notebook to get final segmentation.</p></li>
</ul>
</div>
<div class="section" id="results">
<h2>Results<a class="headerlink" href="#results" title="Permalink to this headline">¶</a></h2>
<p>You can find sample segmentation results and ground truth at this <a href="https://doi.org/10.6084/m9.figshare.14447079.v1">  link </a>.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">3D UNET+ Seeded watershed</a><ul>
<li><a class="reference internal" href="#installation">Installation</a></li>
<li><a class="reference internal" href="#uses">Uses</a></li>
<li><a class="reference internal" href="#results">Results</a></li>
</ul>
</li>
</ul>

  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/descriptions/unet_ws.md.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">3D UNET+ Seeded watershed</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Anuradha Kar.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 3.2.1.
    </div>
  </body>
</html>